/* ================================ Bricker Game =================================
Name: Bricker
Version: 0.0.1
Author: Gulyan
e-mail: gulyan89@yahoo.com
Start date: 14 - Octomber - 2008

program files:
bricker.cpp		-the main file (d'oh) which contains the main function, globals and most function
stdapi.h		-headr file in wich we include all the headers an declare the function prototypes
oop.cpp			-cpp file in wich we define classes

MovieClip Features:
	onPress
	onRelease
	onReleaseOutside
	onRollOver
	onRollOut
	onEnterFrame
	play
	stop
	startDrag
	stopDrag
	gotoAndPlay
	gotoAndStop
	nextFrame
	previousFrame
	setDepth
	setInstance
	GetByInstance

	x
	y
	xmouse
	ymouse
	currentFrame
	totalFrame

*/

#include "stdapi.h"	//Include the file wich containts all the headers we need


// ================================ Global Varibles ===============================
// ================================================================================

SDL_Surface* screen = NULL, *fade;
SDL_Event event;
bool quit = false;
bool gamezone = false;
int fadeValue = 0, fadeSens = 0;
void (*fadeTrigerUp)(void) = NULL, (*fadeTrigerDown)(void) = NULL;
MCBricker *brick_g;
int level = 0;
char abs_path[512];
char level_str[100][LEVELPATH];
int numberOfLevels = 0;


// Set constants
const int SCREEN_WIDTH = 700;
const int SCREEN_HEIGHT = 400;
const char Program_Title[] = "Bricker";
const SDL_VideoInfo * videoInfo;

// ================================ Main function =================================
// ================================================================================

int main(int argc, char *argv[])
{
	srand(time(NULL));

	strcpy(abs_path, argv[0]);
	*(char *)( strrchr(abs_path,'/') + 1) = NULL;
	char file_path[512];

	if(Init() == false){
		// use SDL_Error() to tell us what went wrong
		printf("Unable to initialise program, error is: %s\n\n", SDL_GetError());
	}

	// Make sure SDL shuts down in the event of a crash
	atexit( clean ); //function clean will run when the program exits

	MovieClip::FPS = 33;

	MovieClip  background_mc, logo_mc, tutorial_screen, about_mc;
	MCButton close_btn, play_btn, tut_btn, about_btn, exit_btn, menu_btn, sag_st, sag_dr;
	MCBricker brick_mc;
	MCPlaca placa_demo;

	brick_g = &brick_mc;
	
	sprintf(file_path, "%smedia/back.png", abs_path);
	background_mc.Init(file_path, 1, 700, 400, 700, 1);

	MovieClip::ShowLayer(1);
	sprintf(file_path, "%smedia/back_name.png", abs_path);
	logo_mc.Init(file_path, 1, 700, 400, 700, 2);
	sprintf(file_path, "%smedia/play_btn.png", abs_path);
	play_btn.Init(file_path, 3, 50, 30, 50, 3);
	sprintf(file_path, "%smedia/tut_btn.png", abs_path);
	tut_btn.Init(file_path, 3, 75, 30, 75, 3);
	sprintf(file_path, "%smedia/about_btn.png", abs_path);
	about_btn.Init(file_path, 3, 60, 30, 60, 3);
	sprintf(file_path, "%smedia/exit_btn.png", abs_path);
	exit_btn.Init(file_path, 3, 45, 30, 45, 3);
	sprintf(file_path, "%smedia/about.png", abs_path);
	about_mc.Init(file_path, 1, 468, 183, 468, 4);
	sprintf(file_path, "%smedia/close_btn.png", abs_path);
	close_btn.Init(file_path, 3, 30, 30, 30, 5);

	MovieClip::ShowLayer(2);
	sprintf(file_path, "%smedia/tutorial.png", abs_path);
	tutorial_screen.Init(file_path, 1, 700, 400, 700, 2);
	sprintf(file_path, "%smedia/menu_btn.png", abs_path);
	menu_btn.Init(file_path, 3, 60, 30, 60, 4);

	MovieClip::ShowLayer(3);
	sprintf(file_path, "%smedia/brick.png", abs_path);
	brick_mc.Init(file_path, 115, 250, 188, 3500, 1000);
	sprintf(file_path, "%smedia/placi.png", abs_path);
	placa_demo.Init(file_path, 6, 70, 40, 420, 2);
	sprintf(file_path, "%smedia/left_arr.png", abs_path);
	sag_st.Init(file_path, 3, 33, 39, 33, 1001);
	sprintf(file_path, "%smedia/right_arr.png", abs_path);
	sag_dr.Init(file_path, 3, 33, 39, 33, 1001);

	brick_mc.InitGround( &placa_demo );
	
	placa_demo.visible = false;
	MovieClip::ShowLayer(1);

	play_btn.setXY(500, 210);
	tut_btn.setXY(488, 240);
	about_btn.setXY(495, 270);
	exit_btn.setXY(500, 300);
	menu_btn.setXY(5, 5);
	about_mc.setXY(5, -200);
	close_btn.setXY(430, -190);
	sag_st.setXY(10, 355);
	sag_dr.setXY(50, 355);

	menu_btn.setInstance("menu_btn");
	about_mc.setInstance("about");
	close_btn.setInstance("close_btn");
	brick_mc.setInstance("bricker");

	about_mc.temp_int[0] = -200;
	close_btn.temp_int[1] = 1;

	play_btn.onRelease = gotogame;
	tut_btn.onRelease = gototut;
	about_btn.onRelease = showabout;
	close_btn.onRelease = showabout;
	exit_btn.onRelease = exit_game;
	menu_btn.onRelease = gotomenu;
	about_mc.onEnterFrame = aboutjump;
	sag_st.onRelease = prevlvl;
	sag_dr.onRelease = nextlvl;
	
	brick_mc.Prepare();
	brick_mc.sx = -75;
	brick_mc.sy = -6;

	if (LoadLevelsFile() == false){
		printf("Error loading levels\n");
		quit = true;
	}
	else {
		level = 0;
		NextLevel();
	}

	while(quit == false)
	{
		MovieClip::startFpsTimer();
		//handle events
		while(SDL_PollEvent(&event))
		{
			if( event.type == SDL_QUIT ){quit = true;break;}
			MovieClip::handle_events(event);
		}
		if(quit)break;

		Uint8 * keystates = SDL_GetKeyState(NULL);

		if(keystates[SDLK_ESCAPE] && MovieClip::currentlayer == menu_btn.GetLayer())gotomenu(&menu_btn);

		if(gamezone){
			switch(brick_mc.GetState())
			{
				case 1:
					if(brick_mc.placa[brick_mc.cy][brick_mc.cx]->type == -1);
					break;
			}
			brick_mc.Process();
			if(brick_mc.OnMove() == 0){
				if(keystates[SDLK_UP])brick_mc.Up();
				if(keystates[SDLK_DOWN])brick_mc.Down();
				if(keystates[SDLK_LEFT])brick_mc.Left();
				if(keystates[SDLK_RIGHT])brick_mc.Right();
			}
		}
		//reder MovieClips (sprites)
		MovieClip::Render(screen);
		//fade (if necesary)
		if(fadeValue > 10 || fadeSens){
			fadeValue = (fadeValue > 255 ? 255 : (fadeValue < 0 ? 0 : fadeValue));
			SDL_SetAlpha(fade, SDL_SRCALPHA, fadeValue);
			SDL_BlitSurface( fade, NULL, screen, NULL );
			fadeValue += fadeSens * 10;
			if( fadeValue >= 255 && fadeSens == 1){
				fadeSens = 0;
				if(fadeTrigerUp != NULL)fadeTrigerUp();
			}
			else if( fadeValue < 10)
			{
				fadeSens = 0;
				fadeValue = 0;
				if(fadeTrigerDown != NULL)fadeTrigerDown();
			}
		}
		//flip to screen
		if( SDL_Flip(screen) == -1)
		{
			printf("Error on flip: %s\n\n", SDL_GetError());
			break;
		}
		MovieClip::RegulateFPS();
	}

	return 0;
}


// ================================ Functions =====================================
// ================================================================================

void clean(void)
{
	// Destroy image surface
	SDL_FreeSurface( screen );
	SDL_FreeSurface( fade );
	MovieClip::Clean();	
	SDL_Quit();
}

bool Init(void)
{
	// Initialize SDL video subsystems
    	if( SDL_Init( SDL_INIT_VIDEO ) == -1 ){
		return false;    
	}
	// Set Title
	SDL_WM_SetCaption(Program_Title, Program_Title);
	// Get video information
	videoInfo = SDL_GetVideoInfo();
	long int videoFlags = SDL_DOUBLEBUF;
	if( videoInfo->hw_available)videoFlags |= SDL_HWSURFACE;
	else videoFlags |= SDL_SWSURFACE;
	int bpp = videoInfo->vfmt->BitsPerPixel;
	if(bpp < 32)printf("Warning: not running in 32-bit mode\n");
	// Create screen in software rendering mode.
	screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, bpp, videoFlags);
	if( screen == NULL ){
		printf("Unable to set video mode\n");
		return false;
	}
	videoFlags = SDL_SRCALPHA | SDL_SWSURFACE;
	//if( videoInfo->hw_available)videoFlags = SDL_HWSURFACE;
	//else videoFlags = SDL_SWSURFACE;
	fade = SDL_CreateRGBSurface( videoFlags, SCREEN_WIDTH, SCREEN_HEIGHT, bpp, 0, 0, 0, 0);
	SDL_FillRect(fade, NULL, SDL_MapRGB(screen->format, 0, 153, 204));
	return true;
}
