#include "game.h"

using namespace std;

MCButton::MCButton()
{
	this->onPress = gotoframe3;
	this->onReleaseOutside = gotoframe1;
	this->onRollOver = gotoframe2or3;
	this->onRollOut = gotoframe1;
}

MCPlaca::MCPlaca()
{
	tx = ty = Y = _y = type = 0;
	vis = true;
	fade = 0;
	onEnterFrame = placaframe;
}

MCBricker::MCBricker()
{
	state = 1;
	move = 0;
	fall = 0;
	cx = cy = 0;
	step = 1;
	win = 0;
	sens = 0;
	int i, j;
	for(i = 0; i < 20; i++)
		for(j = 0; j < 20; j++)
			placa[i][j] = NULL;
}

MCBricker::~MCBricker()
{
	int i, j;
	for(i = 0; i < MATH; i++)
		for(j = 0; j < MATW; j++)if(placa[i][j])delete placa[i][j];
	//~MovieClip(); not needed :0
}

void MCBricker::InitGround(MCPlaca *placa_demo)
{
	int i, j;
	for(i = 0; i < MATH; i++)
		for(j = 0; j < MATW; j++)
		{
			placa[i][j] = new MCPlaca;
			placa[i][j]->InitFrom(placa_demo, 2 + 80 + i * 20 - j);
			placa[i][j]->x = j * 36 + i * 9 - 105;
			placa[i][j]->_y = 105 - 10 + i * 15 - j * 3;
			placa[i][j]->y = 0;
		}
}

void MCBricker::Prepare()
{
	state = 1;
	move = 0;
	cx = 0;
	sens = 0;
	cy = 0;
	onEnterFrame = brickerFrame;
	gotoAndStop(84);
}

void MCBricker::Up()
{
	move = 1;
	sens = 1;
	step = 1;
	switch(state)
	{
		case 1:
			gotoAndPlay(14); break;
		case 2:
			cy -= 1; gotoAndStop(69); playReverse(); break;
		case 3:
			cy -= 1; gotoAndStop(13); playReverse(); break;
	}
}

void MCBricker::Down()
{
	move = 1;
	sens = 2;
	step = 1;
	switch(state)
	{
		case 1:
			gotoAndPlay(0); break;
		case 2:
			gotoAndPlay(56); break;
		case 3:
			cy += 2; gotoAndStop(27); playReverse(); break;
	}
}

void MCBricker::Right()
{
	move = 1;
	sens = 3;
	step = 1;
	switch(state)
	{
		case 1:
			gotoAndPlay(28); break;
		case 2:
			cx += 2; gotoAndStop(55); playReverse(); break;
		case 3:
			gotoAndPlay(70); break;
	}
}

void MCBricker::Left()
{
	move = 1;
	sens = 4;
	step = 1;
	switch(state)
	{
		case 1:
			gotoAndPlay(42); break;
		case 2:
			cx -= 1; gotoAndStop(41); playReverse(); break;
		case 3:
			cx -= 1; gotoAndStop(83); playReverse(); break;
	}
}

void MCBricker::PosBricker()
{
	x = sx + cx * 36 + cy * 9 - 105;
	y = sy + Y + cy * 15 - cx * 3;
	if(fall)
	{
		if(Y < -10){ Y += 10; move = 1;}
		else if(Y > 10){ Y -= 10; move = 1;}
		else
		{
			move = 0;
			fall = 0;
			Y = 0;
		}
	}
}

void MCBricker::Process()
{
	if(move)return;
	if(state == 1){
		if(placa[cy][cx]->type == -1){
			move = 1;
			win = 1;
			gotoAndPlay(87);
		}
		else if(placa[cy][cx]->type == 0){
			move = 1;
			fadeSens = 1;
			fadeValue = 0;
			fadeTrigerUp = RestartLevel;
		}
		else if(placa[cy][cx]->type == 2){
			move = 1;
			win = 0;
			placa[cy][cx]->vis = false;
			gotoAndPlay(87);
		}
		else if(placa[cy][cx]->type == 3){
			move = 1;
			tx = placa[cy][cx]->tx;
			ty = placa[cy][cx]->ty;
			gotoAndPlay(98);
		}
		else if(placa[cy][cx]->type == 4 && step == 1){
			step = 0;
			if( placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->type == 0 ){
				placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->type = 5;
				placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->Y = 450 -placa[placa[cy][cx]->ty][placa[cy][cx]->tx]-> _y;
				placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->visible = true;
				placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->fade = 0;
			}
			else{
				placa[placa[cy][cx]->ty][placa[cy][cx]->tx]->fade = 1;
			}
		}
	}
	else if (state == 2){
		if(placa[cy][cx]->type == 0 || placa[cy][cx+1]->type == 0 ){
			move = 1;
			fadeSens = 1;
			fadeValue = 0;
			fadeTrigerUp = RestartLevel;
		}
	}
	else if (state == 3){
		if(placa[cy][cx]->type == 0 || placa[cy+1][cx]->type == 0 ){
			move = 1;
			fadeSens = 1;
			fadeValue = 0;
			fadeTrigerUp = RestartLevel;
		}
	}
}

void MCBricker::setState(int s)
{
	state = s;
}

void brickerFrame(MovieClip* mc)
{
	MCBricker * mcb = (MCBricker *)(mc);
	mcb->PosBricker();
	switch (mcb->currentFrame())
	{
		case 27:
			if(mcb->sens == 1)
			{
				mcb->gotoAndStop(86);
				mcb->cy -= 2;
				mcb->setState(3);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 0:
			if(mcb->sens == 1)
			{
				mcb->gotoAndStop(84);
				mcb->setState(1);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 56:
			if(mcb->sens == 1)
			{
				mcb->gotoAndStop(85);
				mcb->setState(2);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 13:
			if(mcb->sens == 2)
			{
				mcb->gotoAndStop(86);
				mcb->cy += 1;
				mcb->setState(3);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 14:
			if(mcb->sens == 2)
			{
				mcb->gotoAndStop(84);
				mcb->setState(1);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 69:
			if(mcb->sens == 2)
			{
				mcb->gotoAndStop(85);
				mcb->setState(2);
				mcb->cy += 1;
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 41:
			if(mcb->sens == 3)
			{
				mcb->gotoAndStop(85);
				mcb->setState(2);
				mcb->cx += 1;
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 42:
			if(mcb->sens == 3)
			{
				mcb->gotoAndStop(84);
				mcb->setState(1);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 83:
			if(mcb->sens == 3)
			{
				mcb->gotoAndStop(86);
				mcb->setState(3);
				mcb->cx += 1;
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 55:
			if(mcb->sens == 4)
			{
				mcb->gotoAndStop(85);
				mcb->setState(2);
				mcb->cx -= 2;
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 28:
			if(mcb->sens == 4)
			{
				mcb->gotoAndStop(84);
				mcb->setState(1);
				//mcb->cx -= 2;
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 70:
			if(mcb->sens == 4)
			{
				mcb->gotoAndStop(86);
				mcb->setState(3);
				mcb->sens = 0;
				mcb->move = 0;
			}
			break;
		case 97:
			if(fadeSens != 1)
			{
				mcb->stop();
				mcb->move = 1;
				fadeSens = 1;
				fadeValue = 0;
				if( mcb->win == 0 )fadeTrigerUp = RestartLevel;
				else fadeTrigerUp = NextLevel;
			}
			break;
		case 114:
			mcb->cx = mcb->tx;
			mcb->cy = mcb->ty;
			mcb->Y = -600;
			mcb->fall = 1;
			mcb->setState(1);
			mcb->gotoAndStop(84);
	}
	mcb->Process();//prevent bug is moving to fast;
}
