#include "game.h"

using namespace std;

void gotoframe1(MovieClip* mc)
{
	mc->gotoAndStop(0);
}

void gotoframe2(MovieClip* mc)
{
	mc->gotoAndStop(1);
}

void gotoframe3(MovieClip* mc)
{
	mc->gotoAndStop(2);
}

void gotoframe2or3(MovieClip* mc)
{
	if( mc->Pressed())mc->gotoAndStop(2);
	else mc->gotoAndStop(1);
}

void exit_game(MovieClip* mc)
{
	quit = true;
}

void gototut(MovieClip* mc)
{
	MovieClip::ShowLayer(2);
	fadeValue = 255;
	fadeSens = -1;
}

void showabout(MovieClip* mc)
{
	MovieClip *about_mc = NULL, * close_btn = NULL;
	about_mc = MovieClip::GetByInstance("about");
	close_btn = MovieClip::GetByInstance("close_btn");
	if(close_btn == NULL || about_mc == NULL)return;
	if(about_mc->temp_int[1])
	{
		about_mc->temp_int[1] = 0;
		about_mc->temp_int[0] = 20;
		about_mc->temp_float[0] = about_mc->y;
		close_btn->visible = true;
	}
	else
	{
		about_mc->temp_int[1] = 1;
		about_mc->temp_int[0] = -200;
		about_mc->temp_float[0] = about_mc->y;
		close_btn->visible = false;
	}
	mc->Reset();
}

void aboutjump(MovieClip* mc)
{
	if(abs(mc->temp_int[0] - mc->y) < 2)
	{
		mc->y = mc->temp_int[0];
		return;
	}
	mc->visible = true;
	MovieClip *close_btn = MovieClip::GetByInstance("close_btn");
	mc->temp_float[0] += (mc->temp_int[0] - mc->temp_float[0]) / 7;
	mc->y = (int)mc->temp_float[0];
	close_btn->y = mc->y + 10;
}

void gotomenu(MovieClip* mc)
{
	if(brick_g->move)return;
	mc->SetLayer(2);
	gamezone = false;
	MovieClip::ShowLayer(1);
	fadeValue = 255;
	fadeSens = -1;
}

void gotogame(MovieClip *mc)
{
	MovieClip *menu_btn = MovieClip::GetByInstance("menu_btn");
	menu_btn->SetLayer(3);
	MovieClip::ShowLayer(3);
	fadeValue = 255;
	fadeSens = -1;
	gamezone = true;
}

void placaframe(MovieClip *mc)
{
	MCPlaca * mcp = (MCPlaca *)(mc);
	if(!mcp)return;

	if( mcp->fade ){
		mcp->y += 15;
		if(mcp->y >= 450){mcp->fade = 0;mcp->type = 0;}
	}
	else {
		mcp->y = mcp->_y + mcp->Y;
		if(mcp->Y < -6) mcp->Y += 6;
		else if(mcp->Y > 6) mcp->Y -= 6;
		else mcp->Y = 0;
	}

	if(mcp->vis == false){mcp->visible = false; return;}

	switch(mcp->type)
	{
		case 0:
			mcp->visible = false; break;
		case 1:
			mcp->visible = true; mcp->gotoAndStop(0); break;
		case 2:
			mcp->visible = true; mcp->gotoAndStop(1); break;
		case 3:
			mcp->visible = true; mcp->gotoAndStop(2); break;
		case 4:
			mcp->visible = true; mcp->gotoAndStop(3); break;
		case 5:
			mcp->visible = true; mcp->gotoAndStop(4); break;
		case -1:
			mcp->visible = true; mcp->gotoAndStop(6); break;
		default:;
			//mcp->visible = false; break;
	}
}

bool InitLevel(const char * path, MCBricker *brick_mc)
{
	ifstream f1(path);
	if(!f1.is_open()){
		f1.close();
		if(level == 1){
			printf("No levels in game!!\n");
			quit = true;
			return false;
		}
		level = 0;
		NextLevel();
		return false;
	}
	int i, j;
	for(i = 0; i < MATH; i++)
		for(j = 0; j < MATW; j++)
			brick_mc->placa[i][j]->type = brick_mc->placa[i][j]->tx = brick_mc->placa[i][j]->ty = 0;

	int W, H;
	f1 >> W >> H;
	if ( W > MATW || H > MATH){
		level = 0;
		f1.close();
		NextLevel();
		return false;
	}
	int x0, y0;
	f1 >> x0 >> y0;
	int cx, cy;
	f1 >> cx >> cy;
	for(i = y0; i < y0 + H; i++)
		for(j = x0; j < x0 + W; j++)
		{
			f1 >> brick_mc->placa[i][j]->type;
			if( brick_mc->placa[i][j]->type == 3 || brick_mc->placa[i][j]->type == 4 ){
				f1 >> brick_mc->placa[i][j]->tx;
				f1 >> brick_mc->placa[i][j]->ty;
				brick_mc->placa[i][j]->tx += x0;
				brick_mc->placa[i][j]->ty += y0;
			}
		}

	brick_mc->OX = cx + x0;
	brick_mc->OY = cy + y0;
	ResetLevel( brick_mc );
	f1.close();
	return true;
}

void ResetLevel(MCBricker *brick_mc)
{
	int i, j;
	for(i = 0; i < MATH; i++)
		for(j = 0; j < MATW; j++)
		{
			brick_mc->placa[i][j]->Y = 400 + j*40 + i*6 + rand()%20;
			brick_mc->placa[i][j]->visible = true;
			brick_mc->placa[i][j]->vis = true;
			brick_mc->placa[i][j]->fade = 0;
			if(brick_mc->placa[i][j]->type == 5)brick_mc->placa[i][j]->type = 0;
			brick_mc->placa[i][j]->onEnterFrame = placaframe;
		}
	brick_mc->cx = brick_mc->OX;
	brick_mc->cy = brick_mc->OY;
	brick_mc->tx = 0;
	brick_mc->ty = 0;
	brick_mc->Y = -2000;
	brick_mc->fall = 1;
	brick_mc->setState(1);
	brick_mc->gotoAndStop(84);
	brick_mc->win = 0;
	brick_mc->sens = 0;
	brick_mc->step = 1;
}

void RestartLevel()
{
	fadeTrigerUp = NULL;
	fadeValue = 255;
	fadeSens = -1;
	ResetLevel( brick_g );	
}

void NextLevel()
{
	fadeTrigerUp = NULL;
	fadeValue = 255;
	fadeSens = -1;
	level++;
	if(level <= 0)level = numberOfLevels;
	if(level > numberOfLevels)level = 1;
	InitLevel(level_str[level], brick_g );	
}

void PrevLevel()
{
	level -= 2;
	NextLevel();
}

bool LoadLevelsFile()
{
	char file_path[512];
	sprintf(file_path, "%slevels/levels.txt", abs_path);
	ifstream f1(file_path);
	if(!f1.is_open()){
		f1.close();
		return false;
	}
	f1 >> numberOfLevels;
	level = 0;
	int i;
	for ( i = 1; i <= numberOfLevels; i++)
	{
		f1 >> file_path;
		sprintf(level_str[i], "%s%s", abs_path, file_path);
	}
	f1.close();
	return true;
}

void nextlvl(MovieClip *mc)
{
	if( fadeSens )return;
	brick_g->move = 1;
	fadeSens = 1;
	fadeValue = 0;
	fadeTrigerUp = NextLevel;
	mc->gotoAndStop(1);
}

void prevlvl(MovieClip *mc)
{
	if( fadeSens )return;
	brick_g->move = 1;
	fadeSens = 1;
	fadeValue = 0;
	fadeTrigerUp = PrevLevel;
	mc->gotoAndStop(1);
}

