#include "movieclip.h"	//Include the file wich containts all the headers we need

// ================================ MovieClip class ===============================
// ================================================================================

using namespace std;

void MovieClip::UpdateData()
{
	xmouse = xmouse_p;
	ymouse = ymouse_p;
	if( xmouse > 0 && xmouse < w && ymouse > 0 && ymouse < h)
	{
		mouseover = true;
		press = this;
	}
	else mouseover = false;
	if(LBD == false)prs = false;//if left mouse buton is up, we reset the prs(trigger press variable) to false
}

void MovieClip::ReactData()
{
	if(visible == false || (layer != currentlayer && layer != 0) )return;
	if(onEnterFrame != NULL)onEnterFrame(this);//enterframe
	if(mouseover && roll == NULL && onRollOver != NULL)
	{
		roll = this;
		onRollOver(this);
	}
	else if(mouseover == false && roll == this)
	{
		roll = NULL;
		if(onRollOut != NULL)onRollOut(this);
	}
	if(press == this && LBD == true && prs == false)
	{
		prs = true;
		rls = true;
		if(onPress != NULL)onPress(this);//press
	}
	if(LBD == false && rls == true)
	{
		rls = false;
		if(press == this){if(onRelease != NULL)onRelease(this);}//release
		else {if(onReleaseOutside != NULL)onReleaseOutside(this);}//release outside
	}
	if(drag)
	{
		x = xmouse_p_a - xdrag_m;
		y = ymouse_p_a - ydrag_m;
		x = (x<drag_limit.x?drag_limit.x:x);
		x = (x>drag_limit.w?drag_limit.w:x);
		y = (y<drag_limit.y?drag_limit.y:y);
		y = (y>drag_limit.h?drag_limit.h:y);
	}
}

void MovieClip::handle_events(SDL_Event event)
{
	list<MovieClip*>::iterator it;
	for ( it = mc_list.begin(); it != mc_list.end(); it++ )
	if((*it)->visible && ( (*it)->layer == currentlayer || (*it)->layer == 0))
	{
		switch(event.type)
		{
			//If the mouse moved
			case SDL_MOUSEMOTION:
			{
				//Get the mouse offsets
				(*it)->xmouse_p = event.motion.x - (*it)->x;
				(*it)->ymouse_p = event.motion.y - (*it)->y;
				(*it)->xmouse_p_a = event.motion.x;
				(*it)->ymouse_p_a = event.motion.y;
				break;
			}
		}
	}
	switch(event.type)
	{
		case SDL_MOUSEBUTTONDOWN:
		{
			if( event.button.button == SDL_BUTTON_LEFT ){LBD = true;}
			break;
		}
		case SDL_MOUSEBUTTONUP:
		{
			if( event.button.button == SDL_BUTTON_LEFT ){LBD = false;}
			break;
		}
	}
}

void MovieClip::startDrag(int l, int t, int r, int b)
{
	xdrag_m = xmouse_p_a - x;
	ydrag_m = ymouse_p_a - y;
	drag_limit.x = l;
	drag_limit.y = t;
	drag_limit.w = r;//not width but x+width
	drag_limit.h = b;//same as above
	drag = true;
}

void MovieClip::stopDrag()
{
	drag = false;
}

bool MovieClip::Pressed()
{
	return prs;
}


