// ================================ MovieClip class ===============================
// ================================================================================
/*
	Copyright (2008) Guduleasa Alexandru Ionut

*/

#pragma once

// ================================ Headers =======================================
// ================================================================================
#include "SDL/SDL.h"
#include "SDL/SDL_image.h"	
#include <stdio.h>
#include <list>
#include <time.h>
#include <string.h>

using namespace std;

class MovieClip;

class MovieClip
{
	int currentframe, totalframes;
	int height, width;
	SDL_Rect* rectangles;
	SDL_Surface *image;
	SDL_Rect position;
	unsigned int depth;
	int layer;
	int play_var;
	static list<MovieClip*> mc_list;
	static int fps;
	int xmouse_p, ymouse_p;//relative position
	int xmouse_p_a, ymouse_p_a;//absolute position
	int xdrag_m, ydrag_m;//relative position to perform drag
	SDL_Rect drag_limit;//drag limits
	bool mouseover;//mouse over this mc
	bool drag;//drag or not
	bool prs, rls;//bools for press and release
	bool delimage;
	static bool LBD;//left buton down
//uid's
	static MovieClip *roll, *press;
public:
	static int currentlayer;
	static unsigned FPS;
	bool visible;
	int x, y, h, w;
	int xmouse, ymouse;
	short unsigned alpha;
	char instance [128];
	int temp_int[10];//10 temporary integers
	float temp_float[10];//10 temporary floats
//Trigers
	void (*onRollOver)(MovieClip*);
	void (*onRollOut)(MovieClip*);
	void (*onPress)(MovieClip*);
	void (*onRelease)(MovieClip*);
	void (*onReleaseOutside)(MovieClip*);
	void (*onEnterFrame)(MovieClip*);


//Methodes
	MovieClip();
	virtual ~MovieClip();

	static void Render(SDL_Surface*& screen);
	static void handle_events(SDL_Event event);
	static void Clean();
	static void startFpsTimer();
	static void RegulateFPS();
	static void ShowLayer(int Layer);
	static MovieClip* GetByInstance(const char *str);

	void setInstance(const char *str);
	bool Pressed();
	void Reset();
	void UpdateData();
	void ReactData();
	void RenderFrame(SDL_Surface*& screen);
	bool Init(const char *path, int nr_of_frames, int w, int h, int WIDTH, int dep);
	bool InitFrom(MovieClip *mc, int dep);
	void NextFrame(void);
	void PreviousFrame(void);
	SDL_Rect* GetFrame(void);
	int currentFrame();
	int totalFrames();
	void SetFrame( int frame_number, int x, int y, int w, int h);
	void SetFrame( int frame_number, SDL_Rect* rect);
	void SetDepth(unsigned int Depth);
	void SetLayer(int Layer);
	int GetLayer(){return layer;}
	void play();
	void stop();
	void playReverse();
	void gotoAndPlay(int frame);
	void gotoAndStop(int frame);
	void startDrag(int l, int t, int r, int b);
	void stopDrag();
	void setXY(int X, int Y);
private:
	static bool orderByDepth(MovieClip *a, MovieClip *b);
};
